; LZMA compression
SetCompressor /SOLID lzma
SetDatablockOptimize on
CRCCheck on


; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Aimject"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "Jon Oberheide"
!define PRODUCT_WEB_SITE "http://jon.oberheide.org/projects/aimject/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\aimject.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\classic-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\classic-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; Windows version check
Page custom CheckWindowsVersion
; License page
!insertmacro MUI_PAGE_LICENSE "..\COPYING"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_TEXT_REBOOT "Your computer must be restarted in order to complete the installation of Aimject due to several registry changes.  If you do not reboot, Aimject will not function properly.  Do you want to reboot now?"
!define MUI_FINISHPAGE_TEXT_REBOOTNOW "Reboot now"
!define MUI_FINISHPAGE_TEXT_REBOOTLATER "Reboot later"
!insertmacro MUI_PAGE_FINISH
; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES
; Language files
!insertmacro MUI_LANGUAGE "English"
; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "..\aimject-1.0-win32.exe"
InstallDir "$PROGRAMFILES\Aimject"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "Aimject" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite on
  File "..\build\WinPcap_3_1.exe"
  DetailPrint "Installing WinPcap..."
  ExecWait '"$INSTDIR\WinPcap_3_1.exe"'
  WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Services\NPF" "Start" 2
  File "..\build\GTK\bin\xmltok.dll"
  File "..\build\GTK\bin\xmlparse.dll"
  File "..\build\GTK\bin\libxml2.dll"
  File "..\build\GTK\bin\libpng12.dll"
  File "..\build\GTK\bin\libpangowin32-1.0-0.dll"
  File "..\build\GTK\bin\libpangoft2-1.0-0.dll"
  File "..\build\GTK\bin\libpangocairo-1.0-0.dll"
  File "..\build\GTK\bin\libpango-1.0-0.dll"
  File "..\build\GTK\bin\libgtk-win32-2.0-0.dll"
  File "..\build\GTK\bin\libgthread-2.0-0.dll"
  File "..\build\GTK\bin\libgobject-2.0-0.dll"
  File "..\build\GTK\bin\libgmodule-2.0-0.dll"
  File "..\build\GTK\bin\libglib-2.0-0.dll"
  File "..\build\GTK\bin\libglade-2.0-0.dll"
  File "..\build\GTK\bin\libgdk-win32-2.0-0.dll"
  File "..\build\GTK\bin\libgdk_pixbuf-2.0-0.dll"
  File "..\build\GTK\bin\libfreetype-6.dll"
  File "..\build\GTK\bin\libfontconfig-1.dll"
  File "..\build\GTK\bin\libcairo-2.dll"
  File "..\build\GTK\bin\libatk-1.0-0.dll"
  File "..\build\GTK\bin\intl.dll"
  File "..\build\GTK\bin\iconv.dll"
  File "..\build\GTK\bin\zlib1.dll"
  File "..\README"
  File "..\NEWS"
  File "..\COPYING"
  File "..\AUTHORS"
  File "..\data\aimject.glade"
  File "..\data\aimject.png"
  File "..\src\aimject.exe"
  CreateDirectory "$SMPROGRAMS\Aimject"
  CreateShortCut "$SMPROGRAMS\Aimject\Aimject.lnk" "$INSTDIR\aimject.exe"
  CreateShortCut "$DESKTOP\Aimject.lnk" "$INSTDIR\aimject.exe"
  File "..\build\libdnet\lib\libdnet.a"
  SetOutPath "$INSTDIR\etc\fonts"
  File "..\build\GTK\etc\fonts\fonts.conf"
  File "..\build\GTK\etc\fonts\fonts.dtd"
  File "..\build\GTK\etc\fonts\local.conf"
  SetOutPath "$INSTDIR\etc\gtk-2.0"
  File "..\build\GTK\etc\gtk-2.0\gdk-pixbuf.loaders"
  File "..\build\GTK\etc\gtk-2.0\gtk.immodules"
  File "..\build\GTK\etc\gtk-2.0\gtkrc"
  SetOutPath "$INSTDIR\etc\pango"
  File "..\build\GTK\etc\pango\pango.aliases"
  File "..\build\GTK\etc\pango\pango.modules"
  SetOutPath "$INSTDIR\lib\gtk-2.0\2.10.0\engines"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\engines\libpixmap.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\engines\libsvg.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\engines\libwimp.dll"
  SetOutPath "$INSTDIR\lib\gtk-2.0\2.10.0\immodules"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-am-et.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-cedilla.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-cyrillic-translit.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-ime.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-inuktitut.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-ipa.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-thai-broken.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-ti-er.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-ti-et.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\immodules\im-viqr.dll"
  SetOutPath "$INSTDIR\lib\gtk-2.0\2.10.0\loaders"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-ani.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-bmp.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-gif.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-ico.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-jpeg.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-pcx.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-png.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-pnm.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-ras.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-tga.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-tiff.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-wbmp.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-xbm.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-xpm.dll"
  File "..\build\GTK\lib\gtk-2.0\2.10.0\loaders\svg_loader.dll"
  SetOutPath "$INSTDIR\lib\gtk-2.0\2.4.0\engines"
  File "..\build\GTK\lib\gtk-2.0\2.4.0\engines\libmetal.dll"
  File "..\build\GTK\lib\gtk-2.0\2.4.0\engines\libredmond95.dll"
  SetOutPath "$INSTDIR\lib\pango\1.5.0\modules"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-arabic-fc.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-arabic-lang.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-basic-fc.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-basic-win32.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-hangul-fc.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-hebrew-fc.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-indic-fc.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-indic-lang.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-khmer-fc.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-syriac-fc.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-thai-fc.dll"
  File "..\build\GTK\lib\pango\1.5.0\modules\pango-tibetan-fc.dll"
  SetOutPath "$INSTDIR\lib\pkgconfig"
  File "..\build\GTK\lib\pkgconfig\libpng.pc"
  SetOutPath "$INSTDIR\share\themes\Default\gtk-2.0-key"
  File "..\build\GTK\share\themes\Default\gtk-2.0-key\gtkrc"
  SetOutPath "$INSTDIR\share\themes\MS-Windows\gtk-2.0"
  File "..\build\GTK\share\themes\MS-Windows\gtk-2.0\gtkrc"

  WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Services\Tcpip\Parameters" "IPEnableRouter" 1
  WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Services\Tcpip\Parameters" "EnableICMPRedirect" 0
  SetRebootFlag true
SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\Aimject\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\Aimject\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\aimject.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\aimject.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

Function CheckWindowsVersion
   ReadRegStr $R1 HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows NT\CurrentVersion" "CurrentVersion"
   StrCmp $R1 "" 0 GoodVersion
      MessageBox MB_OK|MB_ICONSTOP "Aimject is only supported on Windows 2000/XP/2003."
      Quit
   GoodVersion:
FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\share\themes\Default\gtk-2.0-key\gtkrc"
  Delete "$INSTDIR\share\themes\MS-Windows\gtk-2.0\gtkrc"
  Delete "$INSTDIR\lib\pkgconfig\libpng.pc"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-tibetan-fc.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-thai-fc.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-syriac-fc.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-khmer-fc.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-indic-lang.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-indic-fc.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-hebrew-fc.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-hangul-fc.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-basic-win32.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-basic-fc.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-arabic-lang.dll"
  Delete "$INSTDIR\lib\pango\1.5.0\modules\pango-arabic-fc.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.4.0\engines\libredmond95.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.4.0\engines\libmetal.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\svg_loader.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-xpm.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-xbm.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-wbmp.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-tiff.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-tga.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-ras.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-pnm.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-png.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-pcx.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-jpeg.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-ico.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-gif.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-bmp.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\loaders\libpixbufloader-ani.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-viqr.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-ti-et.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-ti-er.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-thai-broken.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-ipa.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-inuktitut.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-ime.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-cyrillic-translit.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-cedilla.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\immodules\im-am-et.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\engines\libwimp.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\engines\libsvg.dll"
  Delete "$INSTDIR\lib\gtk-2.0\2.10.0\engines\libpixmap.dll"
  Delete "$INSTDIR\etc\pango\pango.modules"
  Delete "$INSTDIR\etc\pango\pango.aliases"
  Delete "$INSTDIR\etc\gtk-2.0\gtkrc"
  Delete "$INSTDIR\etc\gtk-2.0\gtk.immodules"
  Delete "$INSTDIR\etc\gtk-2.0\gdk-pixbuf.loaders"
  Delete "$INSTDIR\etc\fonts\local.conf"
  Delete "$INSTDIR\etc\fonts\fonts.dtd"
  Delete "$INSTDIR\etc\fonts\fonts.conf"
  Delete "$INSTDIR\libdnet.a"
  Delete "$INSTDIR\aimject.exe"
  Delete "$INSTDIR\aimject.png"
  Delete "$INSTDIR\aimject.glade"
  Delete "$INSTDIR\AUTHORS"
  Delete "$INSTDIR\COPYING"
  Delete "$INSTDIR\NEWS"
  Delete "$INSTDIR\README"
  Delete "$INSTDIR\zlib1.dll"
  Delete "$INSTDIR\iconv.dll"
  Delete "$INSTDIR\intl.dll"
  Delete "$INSTDIR\libatk-1.0-0.dll"
  Delete "$INSTDIR\libcairo-2.dll"
  Delete "$INSTDIR\libfontconfig-1.dll"
  Delete "$INSTDIR\libfreetype-6.dll"
  Delete "$INSTDIR\libgdk_pixbuf-2.0-0.dll"
  Delete "$INSTDIR\libgdk-win32-2.0-0.dll"
  Delete "$INSTDIR\libglade-2.0-0.dll"
  Delete "$INSTDIR\libglib-2.0-0.dll"
  Delete "$INSTDIR\libgmodule-2.0-0.dll"
  Delete "$INSTDIR\libgobject-2.0-0.dll"
  Delete "$INSTDIR\libgthread-2.0-0.dll"
  Delete "$INSTDIR\libgtk-win32-2.0-0.dll"
  Delete "$INSTDIR\libpango-1.0-0.dll"
  Delete "$INSTDIR\libpangocairo-1.0-0.dll"
  Delete "$INSTDIR\libpangoft2-1.0-0.dll"
  Delete "$INSTDIR\libpangowin32-1.0-0.dll"
  Delete "$INSTDIR\libxml2.dll"
  Delete "$INSTDIR\libpng12.dll"
  Delete "$INSTDIR\xmlparse.dll"
  Delete "$INSTDIR\xmltok.dll"
  Delete "$INSTDIR\WinPcap_3_1.exe"

  Delete "$SMPROGRAMS\Aimject\Uninstall.lnk"
  Delete "$SMPROGRAMS\Aimject\Website.lnk"
  Delete "$DESKTOP\Aimject.lnk"
  Delete "$SMPROGRAMS\Aimject\Aimject.lnk"

  RMDir "$SMPROGRAMS\Aimject"
  RMDir "$INSTDIR\share\themes\Default\gtk-2.0-key"
  RMDir "$INSTDIR\share\themes\Default"
  RMDir "$INSTDIR\share\themes\MS-Windows\gtk-2.0"
  RMDir "$INSTDIR\share\themes\MS-Windows"
  RMDir "$INSTDIR\share\themes"
  RMDir "$INSTDIR\share"
  RMDir "$INSTDIR\lib\pkgconfig"
  RMDir "$INSTDIR\lib\pango\1.5.0\modules"
  RMDir "$INSTDIR\lib\pango\1.5.0"
  RMDir "$INSTDIR\lib\pango"
  RMDir "$INSTDIR\lib\gtk-2.0\2.4.0\engines"
  RMDir "$INSTDIR\lib\gtk-2.0\2.4.0"
  RMDir "$INSTDIR\lib\gtk-2.0\2.10.0\loaders"
  RMDir "$INSTDIR\lib\gtk-2.0\2.10.0\immodules"
  RMDir "$INSTDIR\lib\gtk-2.0\2.10.0\engines"
  RMDir "$INSTDIR\lib\gtk-2.0\2.10.0"
  RMDir "$INSTDIR\lib\gtk-2.0"
  RMDir "$INSTDIR\lib"
  RMDir "$INSTDIR\etc\pango"
  RMDir "$INSTDIR\etc\gtk-2.0"
  RMDir "$INSTDIR\etc\fonts"
  RMDir "$INSTDIR\etc"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
