/*
 * Aimject
 *
 * Copyright (C) 2006 Jon Oberheide <jon@oberheide.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#include "bsd.h"
#include "main.h"

/* OS-specific setup */
void
os_init(void)
{
	signal(SIGINT, signal_cleanup);
	signal(SIGTERM, signal_cleanup);
	signal(SIGHUP, signal_cleanup);
	signal(SIGPIPE, SIG_IGN);

	if (getuid() != 0 && geteuid() != 0) {
		g_error("root privledges required");
	}
}

/* pcap interface formatting */
gchar *
pcap_intf_name(pcap_if_t *dev)
{
	return dev->name;
}

/* ip forwarding */
gboolean
enable_ip_forwarding(void)
{
	gint val, mib[4];

	val = 1;
	mib[0] = CTL_NET;
	mib[1] = PF_INET;
	mib[2] = IPPROTO_IP;
	mib[3] = IPCTL_FORWARDING;
	if (sysctl(mib, 4, NULL, NULL, &val, sizeof(val)) == -1) {
		return FALSE;
	}

	val = 0;
	mib[0] = CTL_NET;
	mib[1] = PF_INET;
	mib[2] = IPPROTO_IP;
	mib[3] = IPCTL_SENDREDIRECTS;
	if (sysctl(mib, 4, NULL, NULL, &val, sizeof(val)) == -1) {
		return FALSE;
	}

	return TRUE;
}
