/*
 * Aimject
 *
 * Copyright (C) 2006 Jon Oberheide <jon@oberheide.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#include "linux.h"
#include "main.h"

extern aimject_t *aj;

/* OS-specific setup */
void
os_init(void)
{
	signal(SIGINT, signal_cleanup);
	signal(SIGTERM, signal_cleanup);
	signal(SIGHUP, signal_cleanup);
	signal(SIGPIPE, SIG_IGN);

	if (getuid() != 0 && geteuid() != 0) {
		g_error("root privledges required");
	}
}

/* pcap interface formatting */
gchar *
pcap_intf_name(pcap_if_t *dev)
{
	return dev->name;
}

/* ip forwarding */
gboolean
enable_ip_forwarding(void)
{
	FILE *fd;
	gchar *proc;

	fd = fopen("/proc/sys/net/ipv4/ip_forward", "w");
	if (!fd) {
		return FALSE;
	}
	fprintf(fd, "1");
	fclose(fd);

	fd = fopen("/proc/sys/net/ipv4/conf/all/send_redirects", "w");
	if (!fd) {
		return FALSE;
	}
	fprintf(fd, "0");
	fclose(fd);

	proc = g_strdup_printf("/proc/sys/net/ipv4/conf/%s/send_redirects", aj->intf_str_dnet);
	fd = fopen(proc, "w");
	if (!fd) {
		return FALSE;
	}
	fprintf(fd, "0");
	fclose(fd);
	g_free(proc);

	return TRUE;
}
