/*
 * Aimject
 *
 * Copyright (C) 2006 Jon Oberheide <jon@oberheide.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef LINUX_H
#define LINUX_H

#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

/* OS-specific setup */
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
void os_init(void);

/* pcap interface formatting */
#include <pcap.h>
gchar *pcap_intf_name(pcap_if_t *dev);

/* ip forwarding */
gboolean enable_ip_forwarding(void);

/* giochannel creation */
#define g_io_channel_new g_io_channel_unix_new

/* glade handler exporting */
#define EXPORT

/* dn_expand() */
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/nameser.h>
#include <resolv.h>

#endif
