/*
 * Aimject
 *
 * Copyright (C) 2006 Jon Oberheide <jon@oberheide.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef WIN32_H
#define WIN32_H

#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#include <windows.h>

/* OS-specific setup */
#include <winsock2.h>
#include <signal.h>
void os_init(void);

/* pcap interface formatting */
#include <pcap.h>
gchar *pcap_intf_name(pcap_if_t *dev);

/* ip forwarding */
gboolean enable_ip_forwarding(void);

/* giochannel creation */
#define g_io_channel_new g_io_channel_win32_new_socket

/* glade handler exporting */
#define EXPORT		__declspec (dllexport)

/* dn_expand() */
#define T_A		1
#define C_IN		1
#define QUERY		0
#define MAXHOSTNAMELEN	64

#define GETSHORT(s, cp) do { \
	register u_char *t_cp = (u_char *)(cp); \
	(s) = ((u_int16_t)t_cp[0] << 8) \
	    | ((u_int16_t)t_cp[1]) \
	    ; \
	(cp) += 2; \
} while (0)

gint dn_expand(guchar *msg, guchar *eom_orig, guchar *comp_dn, guchar *exp_dn, gint length);

typedef struct {
	unsigned id :16;	/* query identification number */
	unsigned rd :1;		/* recursion desired */
	unsigned tc :1;		/* truncated message */
	unsigned aa :1;		/* authoritive answer */
	unsigned opcode :4;	/* purpose of message */
	unsigned qr :1;		/* response flag */
	unsigned rcode :4;	/* response code */
	unsigned cd :1;		/* checking disabled by resolver */
	unsigned ad :1;		/* authentic data from named */
	unsigned unused :1;	/* unused bits (MBZ as of 4.9.3a3) */
	unsigned ra :1;		/* recursion available */
	unsigned qdcount :16;	/* number of question entries */
	unsigned ancount :16;	/* number of answer entries */
	unsigned nscount :16;	/* number of authority entries */
	unsigned arcount :16;	/* number of resource entries */
} HEADER;

#endif
